/*****************************************************************************
*                                                                            *
* void      Schwellwert(int Grautoene)                                       *
*                                                                            *
******************************************************************************
*                                                                            *
* Ein (Halbton-) Bild wird mit einem einfachen Schwellwertverfahren erzeugt. *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 19.08.1992                                               *
* Letzte Aenderung: 03.09.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: Grautoenne 2, 5, oder 10                                            *
*                                                                            *
******************************************************************************
*                                                                            *
* Output:                                                                    *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: WriteText()                                                    *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Schwellwert(int Grautoene)
{
  int i;
  int GrauTabelle[MAX_COLOR];              /* Grauwert-Uebersetzungstabelle */
  long Index1, Index2, Pixel_Zahl;         /* Adressen der benutzten Bilder */

  WriteText(1, 25, "Bitte etwas Geduld ...");

  /* Erzeugen der Grauton-Uebersetzungstabelle fuer 5 oder 10 Grautoene     */
  switch (Grautoene) {
     case 5:
         for (i=0; i<MAX_COLOR; i++) {
             /* den Bereich von 0..255 in 5 aequidistante Bereiche einteilen*/
             if      (i>200) GrauTabelle[i]=255; /* obere Grenze fuer max.  */
             else if (i>150) GrauTabelle[i]=200; /* Helligkeit am Bildschirm*/
             else if (i>100) GrauTabelle[i]=150;
             else if (i> 50) GrauTabelle[i]=100;
             else            GrauTabelle[i]= 50;
         }
         break;
     case 10:
         for (i=0; i<MAX_COLOR; i++){
             /*den Bereich von 0..255 in 10 aequidistante Bereiche einteilen*/
             if      (i>229) GrauTabelle[i]=255; /* obere Grenze fuer max.  */
             else if (i>204) GrauTabelle[i]=229; /* Helligkeit am Bildschirm*/
             else if (i>178) GrauTabelle[i]=204;
             else if (i>153) GrauTabelle[i]=178;
             else if (i>127) GrauTabelle[i]=153;
             else if (i>102) GrauTabelle[i]=127;
             else if (i> 76) GrauTabelle[i]=102;
             else if (i> 51) GrauTabelle[i]= 76;
             else if (i> 25) GrauTabelle[i]= 51;
             else            GrauTabelle[i]= 25;
         }
  } /* switch */

  /* Gesamtzahl der Pixel berechnen und Bildadressen initialisieren         */
  Pixel_Zahl = (long)Bild[QUELL_PIC].Zeilen * (long)Bild[QUELL_PIC].Spalten;
  Index1 = 0;
  Index2 = PIC_SIZE;
  if (Grautoene==2) {          /* bei 2 Grautoenen ohne Uebersetzungstabelle*/
     for (Index1=0; Index1<Pixel_Zahl; Index1++)
         Pictures[Index2++] = (Pictures[Index1]>=GRAU) ? WEISS:SCHWARZ;
  }
  else {                      /* 5 oder 10 Grautoene, dann Werte aus Tabelle*/
     for (Index1=0; Index1<Pixel_Zahl; Index1++)
         Pictures[Index2++] = GrauTabelle[Pictures[Index1]];
  }

  /* Dimensionen des neuen Bildes in zugehoeriger Struktur abspeichern      */
  Bild[ZIEL_PIC].Zeilen =Bild[QUELL_PIC].Zeilen;
  Bild[ZIEL_PIC].Spalten=Bild[QUELL_PIC].Spalten;

}
